-module(gluple@addition).
-compile([no_auto_import, nowarn_unused_vars, nowarn_unused_function, nowarn_nomatch]).

-export([append1/2, append2/2, append3/2, append4/2, append5/2, append6/2, append7/2, append8/2, append9/2, with_append1/2, with_append2/2, with_append3/2, with_append4/2, with_append5/2, with_append6/2, with_append7/2, with_append8/2, with_append9/2]).

-spec append1({JIK}, JIL) -> {JIK, JIL}.
append1(Tuple, Data) ->
    {erlang:element(1, Tuple), Data}.

-spec append2({JIM, JIN}, JIO) -> {JIM, JIN, JIO}.
append2(Tuple, Data) ->
    {erlang:element(1, Tuple), erlang:element(2, Tuple), Data}.

-spec append3({JIP, JIQ, JIR}, JIS) -> {JIP, JIQ, JIR, JIS}.
append3(Tuple, Data) ->
    {erlang:element(1, Tuple),
        erlang:element(2, Tuple),
        erlang:element(3, Tuple),
        Data}.

-spec append4({JIT, JIU, JIV, JIW}, JIX) -> {JIT, JIU, JIV, JIW, JIX}.
append4(Tuple, Data) ->
    {erlang:element(1, Tuple),
        erlang:element(2, Tuple),
        erlang:element(3, Tuple),
        erlang:element(4, Tuple),
        Data}.

-spec append5({JIY, JIZ, JJA, JJB, JJC}, JJD) -> {JIY, JIZ, JJA, JJB, JJC, JJD}.
append5(Tuple, Data) ->
    {erlang:element(1, Tuple),
        erlang:element(2, Tuple),
        erlang:element(3, Tuple),
        erlang:element(4, Tuple),
        erlang:element(5, Tuple),
        Data}.

-spec append6({JJE, JJF, JJG, JJH, JJI, JJJ}, JJK) -> {JJE,
    JJF,
    JJG,
    JJH,
    JJI,
    JJJ,
    JJK}.
append6(Tuple, Data) ->
    {erlang:element(1, Tuple),
        erlang:element(2, Tuple),
        erlang:element(3, Tuple),
        erlang:element(4, Tuple),
        erlang:element(5, Tuple),
        erlang:element(6, Tuple),
        Data}.

-spec append7({JJL, JJM, JJN, JJO, JJP, JJQ, JJR}, JJS) -> {JJL,
    JJM,
    JJN,
    JJO,
    JJP,
    JJQ,
    JJR,
    JJS}.
append7(Tuple, Data) ->
    {erlang:element(1, Tuple),
        erlang:element(2, Tuple),
        erlang:element(3, Tuple),
        erlang:element(4, Tuple),
        erlang:element(5, Tuple),
        erlang:element(6, Tuple),
        erlang:element(7, Tuple),
        Data}.

-spec append8({JJT, JJU, JJV, JJW, JJX, JJY, JJZ, JKA}, JKB) -> {JJT,
    JJU,
    JJV,
    JJW,
    JJX,
    JJY,
    JJZ,
    JKA,
    JKB}.
append8(Tuple, Data) ->
    {erlang:element(1, Tuple),
        erlang:element(2, Tuple),
        erlang:element(3, Tuple),
        erlang:element(4, Tuple),
        erlang:element(5, Tuple),
        erlang:element(6, Tuple),
        erlang:element(7, Tuple),
        erlang:element(8, Tuple),
        Data}.

-spec append9({JKC, JKD, JKE, JKF, JKG, JKH, JKI, JKJ, JKK}, JKL) -> {JKC,
    JKD,
    JKE,
    JKF,
    JKG,
    JKH,
    JKI,
    JKJ,
    JKK,
    JKL}.
append9(Tuple, Data) ->
    {erlang:element(1, Tuple),
        erlang:element(2, Tuple),
        erlang:element(3, Tuple),
        erlang:element(4, Tuple),
        erlang:element(5, Tuple),
        erlang:element(6, Tuple),
        erlang:element(7, Tuple),
        erlang:element(8, Tuple),
        erlang:element(9, Tuple),
        Data}.

-spec with_append1({JKM}, fun((JKM) -> JKN)) -> {JKM, JKN}.
with_append1(Tuple, Cb) ->
    {erlang:element(1, Tuple), Cb(erlang:element(1, Tuple))}.

-spec with_append2({JKO, JKP}, fun((JKO, JKP) -> JKQ)) -> {JKO, JKP, JKQ}.
with_append2(Tuple, Cb) ->
    {erlang:element(1, Tuple),
        erlang:element(2, Tuple),
        Cb(erlang:element(1, Tuple), erlang:element(2, Tuple))}.

-spec with_append3({JKR, JKS, JKT}, fun((JKR, JKS, JKT) -> JKU)) -> {JKR,
    JKS,
    JKT,
    JKU}.
with_append3(Tuple, Cb) ->
    {erlang:element(1, Tuple),
        erlang:element(2, Tuple),
        erlang:element(3, Tuple),
        Cb(
            erlang:element(1, Tuple),
            erlang:element(2, Tuple),
            erlang:element(3, Tuple)
        )}.

-spec with_append4({JKV, JKW, JKX, JKY}, fun((JKV, JKW, JKX, JKY) -> JKZ)) -> {JKV,
    JKW,
    JKX,
    JKY,
    JKZ}.
with_append4(Tuple, Cb) ->
    {erlang:element(1, Tuple),
        erlang:element(2, Tuple),
        erlang:element(3, Tuple),
        erlang:element(4, Tuple),
        Cb(
            erlang:element(1, Tuple),
            erlang:element(2, Tuple),
            erlang:element(3, Tuple),
            erlang:element(4, Tuple)
        )}.

-spec with_append5(
    {JLA, JLB, JLC, JLD, JLE},
    fun((JLA, JLB, JLC, JLD, JLE) -> JLF)
) -> {JLA, JLB, JLC, JLD, JLE, JLF}.
with_append5(Tuple, Cb) ->
    {erlang:element(1, Tuple),
        erlang:element(2, Tuple),
        erlang:element(3, Tuple),
        erlang:element(4, Tuple),
        erlang:element(5, Tuple),
        Cb(
            erlang:element(1, Tuple),
            erlang:element(2, Tuple),
            erlang:element(3, Tuple),
            erlang:element(4, Tuple),
            erlang:element(5, Tuple)
        )}.

-spec with_append6(
    {JLG, JLH, JLI, JLJ, JLK, JLL},
    fun((JLG, JLH, JLI, JLJ, JLK, JLL) -> JLM)
) -> {JLG, JLH, JLI, JLJ, JLK, JLL, JLM}.
with_append6(Tuple, Cb) ->
    {erlang:element(1, Tuple),
        erlang:element(2, Tuple),
        erlang:element(3, Tuple),
        erlang:element(4, Tuple),
        erlang:element(5, Tuple),
        erlang:element(6, Tuple),
        Cb(
            erlang:element(1, Tuple),
            erlang:element(2, Tuple),
            erlang:element(3, Tuple),
            erlang:element(4, Tuple),
            erlang:element(5, Tuple),
            erlang:element(6, Tuple)
        )}.

-spec with_append7(
    {JLN, JLO, JLP, JLQ, JLR, JLS, JLT},
    fun((JLN, JLO, JLP, JLQ, JLR, JLS, JLT) -> JLU)
) -> {JLN, JLO, JLP, JLQ, JLR, JLS, JLT, JLU}.
with_append7(Tuple, Cb) ->
    {erlang:element(1, Tuple),
        erlang:element(2, Tuple),
        erlang:element(3, Tuple),
        erlang:element(4, Tuple),
        erlang:element(5, Tuple),
        erlang:element(6, Tuple),
        erlang:element(7, Tuple),
        Cb(
            erlang:element(1, Tuple),
            erlang:element(2, Tuple),
            erlang:element(3, Tuple),
            erlang:element(4, Tuple),
            erlang:element(5, Tuple),
            erlang:element(6, Tuple),
            erlang:element(7, Tuple)
        )}.

-spec with_append8(
    {JLV, JLW, JLX, JLY, JLZ, JMA, JMB, JMC},
    fun((JLV, JLW, JLX, JLY, JLZ, JMA, JMB, JMC) -> JMD)
) -> {JLV, JLW, JLX, JLY, JLZ, JMA, JMB, JMC, JMD}.
with_append8(Tuple, Cb) ->
    {erlang:element(1, Tuple),
        erlang:element(2, Tuple),
        erlang:element(3, Tuple),
        erlang:element(4, Tuple),
        erlang:element(5, Tuple),
        erlang:element(6, Tuple),
        erlang:element(7, Tuple),
        erlang:element(8, Tuple),
        Cb(
            erlang:element(1, Tuple),
            erlang:element(2, Tuple),
            erlang:element(3, Tuple),
            erlang:element(4, Tuple),
            erlang:element(5, Tuple),
            erlang:element(6, Tuple),
            erlang:element(7, Tuple),
            erlang:element(8, Tuple)
        )}.

-spec with_append9(
    {JME, JMF, JMG, JMH, JMI, JMJ, JMK, JML, JMM},
    fun((JME, JMF, JMG, JMH, JMI, JMJ, JMK, JML, JMM) -> JMN)
) -> {JME, JMF, JMG, JMH, JMI, JMJ, JMK, JML, JMM, JMN}.
with_append9(Tuple, Cb) ->
    {erlang:element(1, Tuple),
        erlang:element(2, Tuple),
        erlang:element(3, Tuple),
        erlang:element(4, Tuple),
        erlang:element(5, Tuple),
        erlang:element(6, Tuple),
        erlang:element(7, Tuple),
        erlang:element(8, Tuple),
        erlang:element(9, Tuple),
        Cb(
            erlang:element(1, Tuple),
            erlang:element(2, Tuple),
            erlang:element(3, Tuple),
            erlang:element(4, Tuple),
            erlang:element(5, Tuple),
            erlang:element(6, Tuple),
            erlang:element(7, Tuple),
            erlang:element(8, Tuple),
            erlang:element(9, Tuple)
        )}.
